
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega88PA
;Program type             : Application
;Clock frequency          : 19,500000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 256 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88PA
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1279
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x04FF
	.EQU __DSTACK_SIZE=0x0100
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _seek=R4
	.DEF _fl_tik=R3
	.DEF _fl_alarm=R6
	.DEF _old_key=R5
	.DEF _key=R8
	.DEF _dir=R7
	.DEF _reg=R10
	.DEF _stop=R9
	.DEF _fl_speed=R12
	.DEF _lcd_seek=R11
	.DEF _lcd_dig=R14
	.DEF _ten_msec=R13

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0x00

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	RJMP __RESET
	RJMP _ext_int0_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer2_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP _timer1_compa_isr
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00
	RJMP 0x00

_phase_t:
	.DB  0x15,0x15,0x15,0x15,0x15,0x15,0x31,0x31
	.DB  0x31,0x31,0x31,0x31,0x23,0x23,0x23,0x23
	.DB  0x23,0x23,0x2A,0x2A,0x2A,0x2A,0x2A,0x2A
	.DB  0xE,0xE,0xE,0xE,0xE,0xE,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0x23,0x23,0x23,0x23
	.DB  0x23,0x23,0x31,0x31,0x31,0x31,0x31,0x31
	.DB  0x15,0x15,0x15,0x15,0x15,0x15,0x1C,0x1C
	.DB  0x1C,0x1C,0x1C,0x1C,0xE,0xE,0xE,0xE
	.DB  0xE,0xE,0x2A,0x2A,0x2A,0x2A,0x2A,0x2A
_ascii:
	.DB  0x0,0x20,0x5F,0x44,0x9D,0xD5,0xC6,0xD3
	.DB  0xDB,0x45,0xDF,0xD7

_0x3:
	.DB  0xDC,0x5
_0x4:
	.DB  0xE8,0x3
_0x5:
	.DB  0xC8
_0x74:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x1,0x0
	.DB  0x1,0x0,0x0,0x0

__GLOBAL_INI_TBL:
	.DW  0x02
	.DW  _frec
	.DW  _0x3*2

	.DW  0x02
	.DW  _wr
	.DW  _0x4*2

	.DW  0x01
	.DW  _wz
	.DW  _0x5*2

	.DW  0x0C
	.DW  0x03
	.DW  _0x74*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x200

	.CSEG
;/*****************************************************
;Date    : 16.08.2013
;Chip type               : ATmega88PA
;Program type            : Application
;AVR Core Clock frequency: 19,500000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 256
;*****************************************************/
;
;#include <mega88a.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;
;#include <delay.h>
;
;unsigned char seek=0,fl_tik=0,fl_alarm=0;                   // , 1, " ", "-"
;unsigned char old_key=0,key=0,dir=0,reg=0,stop=1,fl_speed=0;       //  
;unsigned char lcd_buf[4]={0x00,0x00,0x00,0x00},lcd_seek=0x01,lcd_dig=0;                    // =0123,   , 
;unsigned char ten_msec=0,speed_count=0,tik=0;                                     // 10  
;unsigned int speed,s_speed=0,t_speed=0,temp,frec=1500;  //  

	.DSEG
;unsigned int del,wr=1000,wz=200;
;
;
;
;flash unsigned char phase_t[2][36]={{0x15,0x15,0x15,0x15,0x15,0x15,       //  36  , 
;                                     0x31,0x31,0x31,0x31,0x31,0x31,
;                                     0x23,0x23,0x23,0x23,0x23,0x23,
;                                     0x2A,0x2A,0x2A,0x2A,0x2A,0x2A,
;                                     0x0E,0x0E,0x0E,0x0E,0x0E,0x0E,
;                                     0x1C,0x1C,0x1C,0x1C,0x1C,0x1C},
;                                    {0x23,0x23,0x23,0x23,0x23,0x23,
;                                     0x31,0x31,0x31,0x31,0x31,0x31,
;                                     0x15,0x15,0x15,0x15,0x15,0x15,
;                                     0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,
;                                     0x0E,0x0E,0x0E,0x0E,0x0E,0x0E,
;                                     0x2A,0x2A,0x2A,0x2A,0x2A,0x2A},
;                                 };
;
;// 
;flash unsigned char ascii[12]={0x00,      //
;                               0x20,      //
;                               0x5f,      //0
;                               0x44,      //1
;                               0x9d,      //2
;                               0xd5,      //3
;                               0xc6,      //4
;                               0xd3,      //5
;                               0xdb,      //6
;                               0x45,      //7
;                               0xdf,      //8
;                               0xd7       //9
;};
;
;
;// External Interrupt 0 service routine
;interrupt [EXT_INT0] void ext_int0_isr(void)           //  
; 0000 0038 {

	.CSEG
_ext_int0_isr:
	ST   -Y,R30
; 0000 0039 PORTC=0x3f;                                               // 
	LDI  R30,LOW(63)
	OUT  0x8,R30
; 0000 003A fl_alarm=1;                                            //  
	LDI  R30,LOW(1)
	MOV  R6,R30
; 0000 003B }
	LD   R30,Y+
	RETI
;
;// Timer1 output compare A interrupt service routine
;interrupt [TIM1_COMPA] void timer1_compa_isr(void)
; 0000 003F   {
_timer1_compa_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R24
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0040    PORTC=0x3f;
	LDI  R30,LOW(63)
	OUT  0x8,R30
; 0000 0041 
; 0000 0042    PORTB.2=0;                                               //  
	CBI  0x5,2
; 0000 0043    SPDR=lcd_seek;
	OUT  0x2E,R11
; 0000 0044    while(!(SPSR&(1<<SPIF)));
_0x8:
	IN   R30,0x2D
	ANDI R30,LOW(0x80)
	BREQ _0x8
; 0000 0045    SPDR=lcd_buf[lcd_dig];
	MOV  R30,R14
	RCALL SUBOPT_0x0
	SUBI R30,LOW(-_lcd_buf)
	SBCI R31,HIGH(-_lcd_buf)
	LD   R30,Z
	OUT  0x2E,R30
; 0000 0046    while(!(SPSR&(1<<SPIF)));
_0xB:
	IN   R30,0x2D
	ANDI R30,LOW(0x80)
	BREQ _0xB
; 0000 0047    PORTB.2=1;
	SBI  0x5,2
; 0000 0048    lcd_seek=lcd_seek<<1;lcd_dig++;
	LSL  R11
	INC  R14
; 0000 0049    if(lcd_seek==0x10) {lcd_seek=0x01,lcd_dig=0;};
	LDI  R30,LOW(16)
	CP   R30,R11
	BRNE _0x10
	LDI  R30,LOW(1)
	MOV  R11,R30
	CLR  R14
_0x10:
; 0000 004A 
; 0000 004B    if(!(fl_alarm||stop))
	TST  R6
	BRNE _0x12
	TST  R9
	BREQ _0x13
_0x12:
	RJMP _0x11
_0x13:
; 0000 004C    {
; 0000 004D     PORTC=phase_t[dir][seek];
	MOV  R30,R7
	LDI  R26,LOW(36)
	MUL  R30,R26
	MOVW R30,R0
	SUBI R30,LOW(-_phase_t*2)
	SBCI R31,HIGH(-_phase_t*2)
	MOVW R26,R30
	MOV  R30,R4
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	LPM  R0,Z
	OUT  0x8,R0
; 0000 004E 
; 0000 004F     if((wz>170)&&(wz<480)) del=163;         //  
	RCALL SUBOPT_0x2
	CPI  R26,LOW(0xAB)
	LDI  R30,HIGH(0xAB)
	CPC  R27,R30
	BRLO _0x15
	RCALL SUBOPT_0x2
	CPI  R26,LOW(0x1E0)
	LDI  R30,HIGH(0x1E0)
	CPC  R27,R30
	BRLO _0x16
_0x15:
	RJMP _0x14
_0x16:
	LDI  R30,LOW(163)
	LDI  R31,HIGH(163)
	RJMP _0x6F
; 0000 0050     else if(wz<171) del=wz-8;               //  50   --> ,  20-50  ,  20    100
_0x14:
	RCALL SUBOPT_0x2
	CPI  R26,LOW(0xAB)
	LDI  R30,HIGH(0xAB)
	CPC  R27,R30
	BRSH _0x18
	RCALL SUBOPT_0x3
	SBIW R30,8
	RJMP _0x6F
; 0000 0051          else del=(wz>>2)+45;
_0x18:
	RCALL SUBOPT_0x3
	RCALL __LSRW2
	ADIW R30,45
_0x6F:
	STS  _del,R30
	STS  _del+1,R31
; 0000 0052     while (--del) delay_us(3);               // 510     170
_0x1A:
	LDI  R26,LOW(_del)
	LDI  R27,HIGH(_del)
	RCALL SUBOPT_0x4
	SBIW R30,0
	BREQ _0x1C
	__DELAY_USB 20
	RJMP _0x1A
_0x1C:
; 0000 0053 };
_0x11:
; 0000 0054   PORTC=0x3f;
	LDI  R30,LOW(63)
	OUT  0x8,R30
; 0000 0055   if(++seek==36) seek=0;
	INC  R4
	LDI  R30,LOW(36)
	CP   R30,R4
	BRNE _0x1D
	CLR  R4
; 0000 0056   }
_0x1D:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R24,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Timer2 overflow interrupt service routine
;interrupt [TIM2_COMPA] void timer2_compa_isr(void)
; 0000 005A {
_timer2_compa_isr:
; 0000 005B 
; 0000 005C }
	RETI
;
; /*
;// Watchdog timeout interrupt service routine
;interrupt [WDT] void wdt_timeout_isr(void)
;{
; #asm("wdr")
; fl_tik=1;
; speed=TCNT0;
; TCNT0=0;
; if(speed<6) fl_speed=1;
;  else fl_speed=0;
; speed_count++;
; if(speed_count>12) {speed_count=0,s_speed=t_speed,t_speed=0;}
;   else t_speed=t_speed+speed;
;}
;*/
;void user_pause(unsigned char time)
; 0000 006E   {
_user_pause:
; 0000 006F     ten_msec=0;
;	time -> Y+0
	CLR  R13
; 0000 0070     while(ten_msec<time) {delay_ms(10),ten_msec++;};
_0x1E:
	LD   R30,Y
	CP   R13,R30
	BRSH _0x20
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	INC  R13
	RJMP _0x1E
_0x20:
; 0000 0071   };
	RJMP _0x2020001
;
;#define ADC_VREF_TYPE 0x40
;
;// Read the AD conversion result
;unsigned int read_adc(unsigned char adc_input)
; 0000 0077 {
_read_adc:
; 0000 0078 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x40
	STS  124,R30
; 0000 0079 // Delay needed for the stabilization of the ADC input voltage
; 0000 007A delay_us(10);
	__DELAY_USB 65
; 0000 007B // Start the AD conversion
; 0000 007C ADCSRA|=0x40;
	LDS  R30,122
	ORI  R30,0x40
	STS  122,R30
; 0000 007D // Wait for the AD conversion to complete
; 0000 007E while ((ADCSRA & 0x10)==0);
_0x21:
	LDS  R30,122
	ANDI R30,LOW(0x10)
	BREQ _0x21
; 0000 007F ADCSRA|=0x10;
	LDS  R30,122
	ORI  R30,0x10
	STS  122,R30
; 0000 0080 return ADCW;
	LDS  R30,120
	LDS  R31,120+1
_0x2020001:
	ADIW R28,1
	RET
; 0000 0081 }
;
;// SPI functions
;#include <spi.h>
;
;void init(void) {
; 0000 0086 void init(void) {
_init:
; 0000 0087 // Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=In Func0=In
; 0000 0088 // State7=T State6=T State5=1 State4=P State3=0 State2=1 State1=P State0=P
; 0000 0089 PORTB=0x37;DDRB=0x2C;
	LDI  R30,LOW(55)
	OUT  0x5,R30
	LDI  R30,LOW(44)
	OUT  0x4,R30
; 0000 008A PORTC=0x7F;DDRC=0x3F;
	LDI  R30,LOW(127)
	OUT  0x8,R30
	LDI  R30,LOW(63)
	OUT  0x7,R30
; 0000 008B // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out
; 0000 008C // State7=P State6=P State5=P State4=T State3=P State2=P State1=0 State0=0
; 0000 008D PORTD=0xEC;DDRD=0x03;
	LDI  R30,LOW(236)
	OUT  0xB,R30
	LDI  R30,LOW(3)
	OUT  0xA,R30
; 0000 008E 
; 0000 008F // Timer/Counter 0 initialization  // Clock source: T0 pin Falling Edge// Mode: Normal top=0xFF
; 0000 0090 TCCR0A=0x00;TCCR0B=0x06;TCNT0=0x00;OCR0A=0x00;OCR0B=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
	LDI  R30,LOW(6)
	OUT  0x25,R30
	LDI  R30,LOW(0)
	OUT  0x26,R30
	OUT  0x27,R30
	OUT  0x28,R30
; 0000 0091 
; 0000 0092 // Timer/Counter 1 initialization  // Clock source: System Clock// Clock value: 304,688 kHz// Mode: CTC top=OCR1A
; 0000 0093 // Input Capture on Falling Edge  / Timer1 Overflow Interrupt: Off// Input Capture Interrupt: Off
; 0000 0094 // Compare A Match Interrupt: On// Compare B Match Interrupt: Off
; 0000 0095 TCCR1A=0x00;TCCR1B=0x0B;TCNT1H=0x00;TCNT1L=0x00;ICR1H=0x00;
	STS  128,R30
	LDI  R30,LOW(11)
	STS  129,R30
	LDI  R30,LOW(0)
	STS  133,R30
	STS  132,R30
	STS  135,R30
; 0000 0096 ICR1L=0x00;OCR1AH=0x00;OCR1AL=0x55;OCR1BH=0x00;OCR1BL=0x00;
	STS  134,R30
	STS  137,R30
	LDI  R30,LOW(85)
	STS  136,R30
	LDI  R30,LOW(0)
	STS  139,R30
	STS  138,R30
; 0000 0097 
; 0000 0098 // Timer/Counter 2 initializatio// Clock value: 19,043 kHz// Mode: CTC top=OCR2A
; 0000 0099 ASSR=0x00;TCCR2A=0x02;TCCR2B=0x07;TCNT2=0x00;OCR2A=0xBE;OCR2B=0x00;
	STS  182,R30
	LDI  R30,LOW(2)
	STS  176,R30
	LDI  R30,LOW(7)
	STS  177,R30
	LDI  R30,LOW(0)
	STS  178,R30
	LDI  R30,LOW(190)
	STS  179,R30
	LDI  R30,LOW(0)
	STS  180,R30
; 0000 009A 
; 0000 009B // External Interrupt(s) initialization
; 0000 009C // INT0: On
; 0000 009D // INT0 Mode: Falling Edge
; 0000 009E EICRA=0x02;EIMSK=0x01;EIFR=0x01;PCICR=0x00;
	LDI  R30,LOW(2)
	STS  105,R30
	LDI  R30,LOW(1)
	OUT  0x1D,R30
	OUT  0x1C,R30
	LDI  R30,LOW(0)
	STS  104,R30
; 0000 009F 
; 0000 00A0 // Timer/Counter Interrupt(s) initialization
; 0000 00A1 TIMSK0=0x00;TIMSK1=0x02;TIMSK2=0x00;
	STS  110,R30
	LDI  R30,LOW(2)
	STS  111,R30
	LDI  R30,LOW(0)
	STS  112,R30
; 0000 00A2 
; 0000 00A3 UCSR0B=0x00;
	STS  193,R30
; 0000 00A4 
; 0000 00A5 ACSR=0x80;ADCSRB=0x00;DIDR1=0x00;
	LDI  R30,LOW(128)
	OUT  0x30,R30
	LDI  R30,LOW(0)
	STS  123,R30
	STS  127,R30
; 0000 00A6 
; 0000 00A7 // ADC initialization
; 0000 00A8 // ADC Clock frequency: 609,375 kHz
; 0000 00A9 // ADC Voltage Reference: AVCC pin
; 0000 00AA // ADC Auto Trigger Source: Free Running
; 0000 00AB // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
; 0000 00AC // ADC4: On, ADC5: On
; 0000 00AD DIDR0=0x00;
	STS  126,R30
; 0000 00AE ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(64)
	STS  124,R30
; 0000 00AF ADCSRA=0xA5;
	LDI  R30,LOW(165)
	STS  122,R30
; 0000 00B0 ADCSRB&=0xF8;
	LDS  R30,123
	ANDI R30,LOW(0xF8)
	STS  123,R30
; 0000 00B1 
; 0000 00B2 // SPI initialization  // SPI Type: Master// SPI Clock Rate: 2*4875,000 kHz// SPI Clock Phase: Cycle Start
; 0000 00B3 // SPI Clock Polarity: Low  // SPI Data Order: MSB First
; 0000 00B4 SPCR=0x50;SPSR=0x01;
	LDI  R30,LOW(80)
	OUT  0x2C,R30
	LDI  R30,LOW(1)
	OUT  0x2D,R30
; 0000 00B5 
; 0000 00B6 // TWI disabled
; 0000 00B7 TWCR=0x00;
	LDI  R30,LOW(0)
	STS  188,R30
; 0000 00B8 /*
; 0000 00B9 // Watchdog Timer initialization
; 0000 00BA // Watchdog Timer Prescaler: OSC/128k
; 0000 00BB // Watchdog Timer interrupt: On
; 0000 00BC #pragma optsize-
; 0000 00BD #asm("wdr")
; 0000 00BE WDTCSR=0x1E;
; 0000 00BF WDTCSR=0x4E;
; 0000 00C0 #ifdef _OPTIMIZE_SIZE_
; 0000 00C1 #pragma optsize+
; 0000 00C2 #endif
; 0000 00C3 */
; 0000 00C4 };
	RET
;
;void lcd_digit(unsigned int temp)
; 0000 00C7    {
_lcd_digit:
; 0000 00C8    if(temp<10000)
;	temp -> Y+0
	RCALL SUBOPT_0x5
	CPI  R26,LOW(0x2710)
	LDI  R30,HIGH(0x2710)
	CPC  R27,R30
	BRSH _0x24
; 0000 00C9      {
; 0000 00CA      lcd_buf[0]=ascii[temp/1000+2];
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	STS  _lcd_buf,R0
; 0000 00CB      lcd_buf[1]=ascii[(temp%1000)/100+2];
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
	__PUTBR0MN _lcd_buf,1
; 0000 00CC      lcd_buf[2]=ascii[((temp%1000)%100)/10+2];
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x7
	__PUTBR0MN _lcd_buf,2
; 0000 00CD      lcd_buf[3]=ascii[((temp%1000)%100)%10+2];
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL __MODW21U
	__ADDW1FN _ascii,2
	LPM  R0,Z
	__PUTBR0MN _lcd_buf,3
; 0000 00CE      }
; 0000 00CF    else
	RJMP _0x25
_0x24:
; 0000 00D0      {
; 0000 00D1      lcd_buf[0]=0x10;
	LDI  R30,LOW(16)
	RCALL SUBOPT_0xA
; 0000 00D2      lcd_buf[1]=0x10;
	LDI  R30,LOW(16)
	RCALL SUBOPT_0xB
; 0000 00D3      lcd_buf[2]=0x10;
	LDI  R30,LOW(16)
	RCALL SUBOPT_0xC
; 0000 00D4      lcd_buf[3]=0x10;
	LDI  R30,LOW(16)
	RCALL SUBOPT_0xD
; 0000 00D5      };
_0x25:
; 0000 00D6    };
	ADIW R28,2
	RET
;
;void razgon(void)
; 0000 00D9   {
_razgon:
; 0000 00DA   if(wz!=wr)
	RCALL SUBOPT_0xE
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x26
; 0000 00DB     {
; 0000 00DC     if(wz<wr)
	RCALL SUBOPT_0xE
	CP   R26,R30
	CPC  R27,R31
	BRSH _0x27
; 0000 00DD      {
; 0000 00DE      if((wr-wz)>1) wr=wr-((wr-wz)>>1);
	RCALL SUBOPT_0xF
	SBIW R30,2
	BRLO _0x28
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x10
	SUB  R26,R30
	SBC  R27,R31
	STS  _wr,R26
	STS  _wr+1,R27
; 0000 00DF      else wr--;
	RJMP _0x29
_0x28:
	LDI  R26,LOW(_wr)
	LDI  R27,HIGH(_wr)
	RCALL SUBOPT_0x4
; 0000 00E0      };
_0x29:
_0x27:
; 0000 00E1     if(wz>wr)
	RCALL SUBOPT_0xE
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x2A
; 0000 00E2      {
; 0000 00E3      if((wz-wr)>1) wr=wr+((wz-wr)>>1);
	RCALL SUBOPT_0x11
	SBIW R30,2
	BRLO _0x2B
	RCALL SUBOPT_0x11
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x12
; 0000 00E4      else wr++;
	RJMP _0x2C
_0x2B:
	LDI  R26,LOW(_wr)
	LDI  R27,HIGH(_wr)
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
; 0000 00E5      };
_0x2C:
_0x2A:
; 0000 00E6      OCR1AH=wz>>8;
	LDS  R30,_wz+1
	STS  137,R30
; 0000 00E7      OCR1AL=wz&0xFF;
	LDS  R30,_wz
	STS  136,R30
; 0000 00E8     };
_0x26:
; 0000 00E9   };
	RET
;
;// Declare your global variables here
;
;void main(void)
; 0000 00EE {
_main:
; 0000 00EF // Declare your local variables here
; 0000 00F0 
; 0000 00F1 // Crystal Oscillator division factor: 1
; 0000 00F2 #pragma optsize-
; 0000 00F3 CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 00F4 CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 00F5 #ifdef _OPTIMIZE_SIZE_
; 0000 00F6 #pragma optsize+
; 0000 00F7 #endif
; 0000 00F8 
; 0000 00F9 init();
	RCALL _init
; 0000 00FA lcd_buf[0]=0xd3,lcd_buf[1]=0x9a,lcd_buf[2]=0x5f,lcd_buf[3]=0x8f;   //"STOP"
	RCALL SUBOPT_0x13
	LDI  R30,LOW(95)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(143)
	RCALL SUBOPT_0xD
; 0000 00FB // Global enable interrupts
; 0000 00FC #asm("sei")
	sei
; 0000 00FD 
; 0000 00FE while (1)
_0x2D:
; 0000 00FF       { old_key=((~PIND)&0xe0)>>5;
	RCALL SUBOPT_0x14
	MOV  R5,R30
; 0000 0100         delay_ms(20);
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
; 0000 0101         key=((~PIND)&0xe0)>>5;
	RCALL SUBOPT_0x14
	MOV  R8,R30
; 0000 0102         if(key!=2) {
	LDI  R30,LOW(2)
	CP   R30,R8
	BREQ _0x30
; 0000 0103         if(old_key!=key) key=0;
	CP   R8,R5
	BREQ _0x31
	CLR  R8
; 0000 0104         };
_0x31:
_0x30:
; 0000 0105 
; 0000 0106       switch (key) {
	MOV  R30,R8
	RCALL SUBOPT_0x0
; 0000 0107       case 0: {};
	SBIW R30,0
	BRNE _0x35
; 0000 0108       break;
	RJMP _0x34
; 0000 0109 
; 0000 010A       case 7:
_0x35:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x36
; 0000 010B          {
; 0000 010C          lcd_buf[0]=0x4f,lcd_buf[1]=0xd6,lcd_buf[2]=0x1b,lcd_buf[3]=0xce;  //""
	LDI  R30,LOW(79)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(214)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(27)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(206)
	RCALL SUBOPT_0xD
; 0000 010D          wr=1000;
	RCALL SUBOPT_0x15
; 0000 010E          //while(!fl_speed);              //  
; 0000 010F          user_pause(100);
	RCALL SUBOPT_0x16
; 0000 0110          PORTD.0=1;                     //  
	SBI  0xB,0
; 0000 0111          user_pause(100);
	RCALL SUBOPT_0x16
; 0000 0112          PORTD.1=1;                     //   
	SBI  0xB,1
; 0000 0113          user_pause(100);
	RCALL SUBOPT_0x16
; 0000 0114          wr=1000;
	RCALL SUBOPT_0x15
; 0000 0115          stop=0;                        // 
	CLR  R9
; 0000 0116           };
; 0000 0117       break;
	RJMP _0x34
; 0000 0118 
; 0000 0119       case 2:
_0x36:
	RCALL SUBOPT_0x17
	BRNE _0x3B
; 0000 011A          {
; 0000 011B          stop=1,wr=1000;PORTD.0=0,PORTD.1=0,fl_alarm=0;
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
	CLR  R6
; 0000 011C          lcd_buf[0]=0xd3,lcd_buf[1]=0x9a,lcd_buf[2]=0x5f,lcd_buf[3]=0x8f;   //"STOP"
	RCALL SUBOPT_0x13
	LDI  R30,LOW(95)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(143)
	RCALL SUBOPT_0xD
; 0000 011D          };
; 0000 011E       break;
	RJMP _0x34
; 0000 011F 
; 0000 0120       case 3:
_0x3B:
	RCALL SUBOPT_0x1A
	BRNE _0x40
; 0000 0121          {
; 0000 0122          if(++reg==5) reg=0;
	INC  R10
	LDI  R30,LOW(5)
	CP   R30,R10
	BRNE _0x41
	CLR  R10
; 0000 0123          switch (reg)
_0x41:
	MOV  R30,R10
	RCALL SUBOPT_0x0
; 0000 0124            {
; 0000 0125            case 0:  lcd_buf[0]=0x00,lcd_buf[1]=0xc6,lcd_buf[2]=0x1b,lcd_buf[3]=0x45; //""
	SBIW R30,0
	BRNE _0x45
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(198)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(27)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(69)
	RJMP _0x70
; 0000 0126            break;
; 0000 0127            case 1:  lcd_buf[0]=0x00,lcd_buf[1]=0x45,lcd_buf[2]=0x5f,lcd_buf[3]=0xce; //""
_0x45:
	RCALL SUBOPT_0x1B
	BRNE _0x46
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(69)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(95)
	RJMP _0x71
; 0000 0128            break;
; 0000 0129            case 2:  lcd_buf[0]=0xce,lcd_buf[1]=0xcf,lcd_buf[2]=0x4f,lcd_buf[3]=0x8f; //""
_0x46:
	RCALL SUBOPT_0x17
	BRNE _0x47
	LDI  R30,LOW(206)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(207)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(79)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(143)
	RJMP _0x70
; 0000 012A            break;
; 0000 012B            case 3:  lcd_buf[0]=0x1b,lcd_buf[1]=0xce,lcd_buf[2]=0x5f,lcd_buf[3]=0x8f; //""
_0x47:
	RCALL SUBOPT_0x1A
	BRNE _0x48
	LDI  R30,LOW(27)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(206)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(95)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(143)
	RJMP _0x70
; 0000 012C            break;
; 0000 012D            case 4:  lcd_buf[0]=0x45,lcd_buf[1]=0x5f,lcd_buf[2]=0xc6,lcd_buf[3]=0xce; //""
_0x48:
	RCALL SUBOPT_0x1C
	BRNE _0x44
	LDI  R30,LOW(69)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(95)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(198)
_0x71:
	__PUTB1MN _lcd_buf,2
	LDI  R30,LOW(206)
_0x70:
	__PUTB1MN _lcd_buf,3
; 0000 012E            break;
; 0000 012F            };
_0x44:
; 0000 0130          user_pause(200);
	LDI  R30,LOW(200)
	RCALL SUBOPT_0x1D
; 0000 0131          };
; 0000 0132       break;
	RJMP _0x34
; 0000 0133 
; 0000 0134       case 1:
_0x40:
	RCALL SUBOPT_0x1B
	BRNE _0x4A
; 0000 0135          {
; 0000 0136          stop=1,wr=1000;PORTD.0=0,PORTD.1=0;
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
; 0000 0137          user_pause(30);
	LDI  R30,LOW(30)
	RCALL SUBOPT_0x1D
; 0000 0138          dir=0;
	CLR  R7
; 0000 0139          lcd_buf[0]=0x4f,lcd_buf[1]=0x8f,lcd_buf[2]=0xcf,lcd_buf[3]=0xdf;       //""
	LDI  R30,LOW(79)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(143)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(207)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(223)
	RCALL SUBOPT_0xD
; 0000 013A          user_pause(50);
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x1D
; 0000 013B          };
; 0000 013C       break;
	RJMP _0x34
; 0000 013D 
; 0000 013E       case 6:
_0x4A:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x4F
; 0000 013F          {
; 0000 0140          stop=1,wr=1000;PORTD.0=0,PORTD.1=0;
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
; 0000 0141          user_pause(30);
	LDI  R30,LOW(30)
	RCALL SUBOPT_0x1D
; 0000 0142          dir=1;
	LDI  R30,LOW(1)
	MOV  R7,R30
; 0000 0143          lcd_buf[0]=0xcc,lcd_buf[1]=0x9b,lcd_buf[2]=0xdf,lcd_buf[3]=0x5f;       //""
	LDI  R30,LOW(204)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(155)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(223)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(95)
	RCALL SUBOPT_0xD
; 0000 0144          user_pause(50);
	LDI  R30,LOW(50)
	RCALL SUBOPT_0x1D
; 0000 0145          };
; 0000 0146       break;
	RJMP _0x34
; 0000 0147 
; 0000 0148       case 5:  if(frec<3000)
_0x4F:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x54
	RCALL SUBOPT_0x1E
	CPI  R26,LOW(0xBB8)
	LDI  R30,HIGH(0xBB8)
	CPC  R27,R30
	BRSH _0x55
; 0000 0149                  {
; 0000 014A                  frec=frec+(frec>>5),key=0;      // 
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x20
	CLR  R8
; 0000 014B                  if(frec>3000) frec=3000;
	RCALL SUBOPT_0x1E
	CPI  R26,LOW(0xBB9)
	LDI  R30,HIGH(0xBB9)
	CPC  R27,R30
	BRLO _0x56
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x20
; 0000 014C                  wz=253895/frec;
_0x56:
	RCALL SUBOPT_0x21
; 0000 014D                  razgon();
; 0000 014E                  };
_0x55:
; 0000 014F       break;
	RJMP _0x34
; 0000 0150 
; 0000 0151       case 4:  if(frec>200)
_0x54:
	RCALL SUBOPT_0x1C
	BRNE _0x34
	RCALL SUBOPT_0x1E
	CPI  R26,LOW(0xC9)
	LDI  R30,HIGH(0xC9)
	CPC  R27,R30
	BRLO _0x58
; 0000 0152                  {
; 0000 0153                  frec=frec-(frec>>5),key=0;      // 
	RCALL SUBOPT_0x1F
	SUB  R26,R30
	SBC  R27,R31
	STS  _frec,R26
	STS  _frec+1,R27
	CLR  R8
; 0000 0154                  if(frec<200) frec=200;
	RCALL SUBOPT_0x1E
	CPI  R26,LOW(0xC8)
	LDI  R30,HIGH(0xC8)
	CPC  R27,R30
	BRSH _0x59
	LDI  R30,LOW(200)
	LDI  R31,HIGH(200)
	RCALL SUBOPT_0x20
; 0000 0155                  wz=253895/frec;
_0x59:
	RCALL SUBOPT_0x21
; 0000 0156                  razgon();
; 0000 0157                  };
_0x58:
; 0000 0158       break;
; 0000 0159       };
_0x34:
; 0000 015A 
; 0000 015B       if(fl_alarm)               // ,
	TST  R6
	BREQ _0x5A
; 0000 015C         {
; 0000 015D         stop=1;wr=1000;PORTD.0=0,PORTD.1=0;
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x19
; 0000 015E         lcd_buf[0]=0x0b,lcd_buf[1]=0x8f,lcd_buf[2]=0xd6,lcd_buf[3]=0xd5; //""
	LDI  R30,LOW(11)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(143)
	RCALL SUBOPT_0xB
	LDI  R30,LOW(214)
	RCALL SUBOPT_0xC
	LDI  R30,LOW(213)
	RCALL SUBOPT_0xD
; 0000 015F         };
_0x5A:
; 0000 0160 
; 0000 0161       if(tik>=10) {
	LDS  R26,_tik
	CPI  R26,LOW(0xA)
	BRLO _0x5F
; 0000 0162       tik=0;
	LDI  R30,LOW(0)
	STS  _tik,R30
; 0000 0163       fl_tik=1;
	LDI  R30,LOW(1)
	MOV  R3,R30
; 0000 0164       speed=TCNT0;
	IN   R30,0x26
	RCALL SUBOPT_0x0
	STS  _speed,R30
	STS  _speed+1,R31
; 0000 0165       TCNT0=0;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 0166       if(speed<6) fl_speed=1;
	LDS  R26,_speed
	LDS  R27,_speed+1
	SBIW R26,6
	BRSH _0x60
	LDI  R30,LOW(1)
	MOV  R12,R30
; 0000 0167         else fl_speed=0;
	RJMP _0x61
_0x60:
	CLR  R12
; 0000 0168       speed_count++;
_0x61:
	LDS  R30,_speed_count
	SUBI R30,-LOW(1)
	STS  _speed_count,R30
; 0000 0169       if(speed_count>12) {speed_count=0,s_speed=t_speed,t_speed=0;}
	LDS  R26,_speed_count
	CPI  R26,LOW(0xD)
	BRLO _0x62
	LDI  R30,LOW(0)
	STS  _speed_count,R30
	LDS  R30,_t_speed
	LDS  R31,_t_speed+1
	STS  _s_speed,R30
	STS  _s_speed+1,R31
	LDI  R30,LOW(0)
	STS  _t_speed,R30
	STS  _t_speed+1,R30
; 0000 016A         else t_speed=t_speed+speed;
	RJMP _0x63
_0x62:
	RCALL SUBOPT_0x22
	LDS  R26,_t_speed
	LDS  R27,_t_speed+1
	RCALL SUBOPT_0x1
	STS  _t_speed,R30
	STS  _t_speed+1,R31
; 0000 016B        } else tik++;
_0x63:
	RJMP _0x64
_0x5F:
	LDS  R30,_tik
	SUBI R30,-LOW(1)
	STS  _tik,R30
; 0000 016C 
; 0000 016D       if(fl_tik)                             //      1 
_0x64:
	TST  R3
	BREQ _0x65
; 0000 016E         {
; 0000 016F         fl_tik=0;                            //  1
	CLR  R3
; 0000 0170 
; 0000 0171         razgon();
	RCALL _razgon
; 0000 0172 
; 0000 0173         switch (reg) {
	MOV  R30,R10
	RCALL SUBOPT_0x0
; 0000 0174          case 0: {lcd_digit(frec);};         //  
	SBIW R30,0
	BRNE _0x69
	LDS  R30,_frec
	LDS  R31,_frec+1
	RJMP _0x72
; 0000 0175          break;
; 0000 0176 
; 0000 0177          case 1:
_0x69:
	RCALL SUBOPT_0x1B
	BRNE _0x6A
; 0000 0178           {
; 0000 0179           temp=read_adc(6);                  // 
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
; 0000 017A           temp=(read_adc(6))<<2;
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x23
	RCALL __LSLW2
	RCALL SUBOPT_0x25
; 0000 017B           lcd_digit(temp);
	RJMP _0x72
; 0000 017C           };
; 0000 017D          break;
; 0000 017E 
; 0000 017F          case 2:
_0x6A:
	RCALL SUBOPT_0x17
	BRNE _0x6B
; 0000 0180           {
; 0000 0181           temp=read_adc(7);                   // 
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x23
	RCALL SUBOPT_0x24
; 0000 0182           temp=read_adc(7)>>1;
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x23
	LSR  R31
	ROR  R30
	RCALL SUBOPT_0x25
; 0000 0183           lcd_digit(temp-(temp>>4));
	RCALL __LSRW4
	LDS  R26,_temp
	LDS  R27,_temp+1
	SUB  R26,R30
	SBC  R27,R31
	ST   -Y,R27
	ST   -Y,R26
	RJMP _0x73
; 0000 0184           };
; 0000 0185          break;
; 0000 0186 
; 0000 0187          case 3:
_0x6B:
	RCALL SUBOPT_0x1A
	BRNE _0x6C
; 0000 0188           {
; 0000 0189           lcd_digit((speed<<3)+(speed<<2));   //  
	RCALL SUBOPT_0x22
	RCALL __LSLW3
	MOVW R26,R30
	RCALL SUBOPT_0x22
	RCALL __LSLW2
	RCALL SUBOPT_0x1
	RJMP _0x72
; 0000 018A           };
; 0000 018B          break;
; 0000 018C 
; 0000 018D          case 4:
_0x6C:
	RCALL SUBOPT_0x1C
	BRNE _0x68
; 0000 018E           {
; 0000 018F           lcd_digit(s_speed);                 //  
	LDS  R30,_s_speed
	LDS  R31,_s_speed+1
_0x72:
	ST   -Y,R31
	ST   -Y,R30
_0x73:
	RCALL _lcd_digit
; 0000 0190           };
; 0000 0191          break;
; 0000 0192         };
_0x68:
; 0000 0193 
; 0000 0194       };
_0x65:
; 0000 0195       }
	RJMP _0x2D
; 0000 0196 }
_0x6E:
	RJMP _0x6E
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif

	.CSEG

	.DSEG
_lcd_buf:
	.BYTE 0x4
_speed_count:
	.BYTE 0x1
_tik:
	.BYTE 0x1
_speed:
	.BYTE 0x2
_s_speed:
	.BYTE 0x2
_t_speed:
	.BYTE 0x2
_temp:
	.BYTE 0x2
_frec:
	.BYTE 0x2
_del:
	.BYTE 0x2
_wr:
	.BYTE 0x2
_wz:
	.BYTE 0x2

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x0:
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	ADD  R30,R26
	ADC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x2:
	LDS  R26,_wz
	LDS  R27,_wz+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3:
	LDS  R30,_wz
	LDS  R31,_wz+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	LD   R30,X+
	LD   R31,X+
	SBIW R30,1
	ST   -X,R31
	ST   -X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LD   R26,Y
	LDD  R27,Y+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x6:
	RCALL SUBOPT_0x5
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x7:
	RCALL __DIVW21U
	__ADDW1FN _ascii,2
	LPM  R0,Z
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x8:
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	RCALL __MODW21U
	MOVW R26,R30
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xA:
	STS  _lcd_buf,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xB:
	__PUTB1MN _lcd_buf,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xC:
	__PUTB1MN _lcd_buf,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xD:
	__PUTB1MN _lcd_buf,3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	LDS  R30,_wr
	LDS  R31,_wr+1
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xF:
	RCALL SUBOPT_0x2
	LDS  R30,_wr
	LDS  R31,_wr+1
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	LSR  R31
	ROR  R30
	LDS  R26,_wr
	LDS  R27,_wr+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x11:
	LDS  R26,_wr
	LDS  R27,_wr+1
	RCALL SUBOPT_0x3
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x12:
	STS  _wr,R30
	STS  _wr+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	LDI  R30,LOW(211)
	RCALL SUBOPT_0xA
	LDI  R30,LOW(154)
	RJMP SUBOPT_0xB

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x14:
	IN   R30,0x9
	COM  R30
	ANDI R30,LOW(0xE0)
	RCALL SUBOPT_0x0
	ASR  R31
	ROR  R30
	RCALL __ASRW4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(100)
	ST   -Y,R30
	RJMP _user_pause

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x17:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(1)
	MOV  R9,R30
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	CBI  0xB,0
	CBI  0xB,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1A:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1B:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	ST   -Y,R30
	RJMP _user_pause

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x1E:
	LDS  R26,_frec
	LDS  R27,_frec+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1F:
	RCALL SUBOPT_0x1E
	LDI  R30,LOW(5)
	RCALL __LSRW12
	RJMP SUBOPT_0x1E

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x20:
	STS  _frec,R30
	STS  _frec+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x21:
	LDS  R30,_frec
	LDS  R31,_frec+1
	CLR  R22
	CLR  R23
	__GETD2N 0x3DFC7
	RCALL __DIVD21
	STS  _wz,R30
	STS  _wz+1,R31
	RJMP _razgon

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x22:
	LDS  R30,_speed
	LDS  R31,_speed+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	ST   -Y,R30
	RJMP _read_adc

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x24:
	STS  _temp,R30
	STS  _temp+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x25:
	RCALL SUBOPT_0x24
	LDS  R30,_temp
	LDS  R31,_temp+1
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x130B
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__ASRW4:
	ASR  R31
	ROR  R30
__ASRW3:
	ASR  R31
	ROR  R30
__ASRW2:
	ASR  R31
	ROR  R30
	ASR  R31
	ROR  R30
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

;END OF CODE MARKER
__END_OF_CODE:
