/*****************************************************
Date    : 16.08.2013
Chip type               : ATmega88PA
Program type            : Application
AVR Core Clock frequency: 19,500000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 256
*****************************************************/

#include <mega88a.h>

#include <delay.h>

unsigned char seek=0,fl_tik=0,fl_alarm=0;                   // , 1, " ", "-"
unsigned char old_key=0,key=0,dir=0,reg=0,stop=1,fl_speed=0;       //  
unsigned char lcd_buf[4]={0x00,0x00,0x00,0x00},lcd_seek=0x01,lcd_dig=0;                    // =0123,   , 
unsigned char ten_msec=0,speed_count=0,tik=0;                                     // 10  
unsigned int speed,s_speed=0,t_speed=0,temp,frec=1500;  //  
unsigned int del,wr=1000,wz=200;       



flash unsigned char phase_t[2][36]={{0x15,0x15,0x15,0x15,0x15,0x15,       //  36  , 
                                     0x31,0x31,0x31,0x31,0x31,0x31,
                                     0x23,0x23,0x23,0x23,0x23,0x23,
                                     0x2A,0x2A,0x2A,0x2A,0x2A,0x2A,
                                     0x0E,0x0E,0x0E,0x0E,0x0E,0x0E,
                                     0x1C,0x1C,0x1C,0x1C,0x1C,0x1C},
                                    {0x23,0x23,0x23,0x23,0x23,0x23,
                                     0x31,0x31,0x31,0x31,0x31,0x31,
                                     0x15,0x15,0x15,0x15,0x15,0x15,
                                     0x1C,0x1C,0x1C,0x1C,0x1C,0x1C,
                                     0x0E,0x0E,0x0E,0x0E,0x0E,0x0E,
                                     0x2A,0x2A,0x2A,0x2A,0x2A,0x2A},
                                 }; 
                                 
//                                  
flash unsigned char ascii[12]={0x00,      //
                               0x20,      //
                               0x5f,      //0
                               0x44,      //1
                               0x9d,      //2
                               0xd5,      //3
                               0xc6,      //4
                               0xd3,      //5
                               0xdb,      //6
                               0x45,      //7
                               0xdf,      //8
                               0xd7       //9
};                                        
                                 
                                 
// External Interrupt 0 service routine
interrupt [EXT_INT0] void ext_int0_isr(void)           //  
{
PORTC=0x3f;                                               // 
fl_alarm=1;                                            //  
}

// Timer1 output compare A interrupt service routine
interrupt [TIM1_COMPA] void timer1_compa_isr(void)
  {
   PORTC=0x3f;

   PORTB.2=0;                                               //  
   SPDR=lcd_seek;
   while(!(SPSR&(1<<SPIF)));
   SPDR=lcd_buf[lcd_dig];
   while(!(SPSR&(1<<SPIF)));
   PORTB.2=1;
   lcd_seek=lcd_seek<<1;lcd_dig++;
   if(lcd_seek==0x10) {lcd_seek=0x01,lcd_dig=0;}; 
   
   if(!(fl_alarm||stop)) 
   {
    PORTC=phase_t[dir][seek];

    if((wz>170)&&(wz<480)) del=163;         //  
    else if(wz<171) del=wz-8;               //  50   --> ,  20-50  ,  20    100
         else del=(wz>>2)+45;
    while (--del) delay_us(3);               // 510     170
    };
  PORTC=0x3f;
  if(++seek==36) seek=0;
  }      

// Timer2 overflow interrupt service routine
interrupt [TIM2_COMPA] void timer2_compa_isr(void)
{

}

 /*
// Watchdog timeout interrupt service routine
interrupt [WDT] void wdt_timeout_isr(void)
{
 #asm("wdr")
 fl_tik=1;
 speed=TCNT0;
 TCNT0=0;
 if(speed<6) fl_speed=1;
  else fl_speed=0;
 speed_count++;
 if(speed_count>12) {speed_count=0,s_speed=t_speed,t_speed=0;}
   else t_speed=t_speed+speed;
}
*/
void user_pause(unsigned char time)
  { 
    ten_msec=0;
    while(ten_msec<time) {delay_ms(10),ten_msec++;};
  };
  
#define ADC_VREF_TYPE 0x40

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
// Delay needed for the stabilization of the ADC input voltage
delay_us(10);
// Start the AD conversion
ADCSRA|=0x40;
// Wait for the AD conversion to complete
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}

// SPI functions
#include <spi.h>

void init(void) {
// Func7=In Func6=In Func5=Out Func4=In Func3=Out Func2=Out Func1=In Func0=In 
// State7=T State6=T State5=1 State4=P State3=0 State2=1 State1=P State0=P 
PORTB=0x37;DDRB=0x2C;
PORTC=0x7F;DDRC=0x3F;
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=Out 
// State7=P State6=P State5=P State4=T State3=P State2=P State1=0 State0=0 
PORTD=0xEC;DDRD=0x03;

// Timer/Counter 0 initialization  // Clock source: T0 pin Falling Edge// Mode: Normal top=0xFF
TCCR0A=0x00;TCCR0B=0x06;TCNT0=0x00;OCR0A=0x00;OCR0B=0x00;

// Timer/Counter 1 initialization  // Clock source: System Clock// Clock value: 304,688 kHz// Mode: CTC top=OCR1A
// Input Capture on Falling Edge  / Timer1 Overflow Interrupt: Off// Input Capture Interrupt: Off
// Compare A Match Interrupt: On// Compare B Match Interrupt: Off
TCCR1A=0x00;TCCR1B=0x0B;TCNT1H=0x00;TCNT1L=0x00;ICR1H=0x00;
ICR1L=0x00;OCR1AH=0x00;OCR1AL=0x55;OCR1BH=0x00;OCR1BL=0x00;

// Timer/Counter 2 initializatio// Clock value: 19,043 kHz// Mode: CTC top=OCR2A
ASSR=0x00;TCCR2A=0x02;TCCR2B=0x07;TCNT2=0x00;OCR2A=0xBE;OCR2B=0x00;

// External Interrupt(s) initialization
// INT0: On
// INT0 Mode: Falling Edge
EICRA=0x02;EIMSK=0x01;EIFR=0x01;PCICR=0x00;

// Timer/Counter Interrupt(s) initialization
TIMSK0=0x00;TIMSK1=0x02;TIMSK2=0x00;

UCSR0B=0x00;

ACSR=0x80;ADCSRB=0x00;DIDR1=0x00;

// ADC initialization
// ADC Clock frequency: 609,375 kHz
// ADC Voltage Reference: AVCC pin
// ADC Auto Trigger Source: Free Running
// Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
// ADC4: On, ADC5: On
DIDR0=0x00;
ADMUX=ADC_VREF_TYPE & 0xff;
ADCSRA=0xA5;
ADCSRB&=0xF8;

// SPI initialization  // SPI Type: Master// SPI Clock Rate: 2*4875,000 kHz// SPI Clock Phase: Cycle Start
// SPI Clock Polarity: Low  // SPI Data Order: MSB First
SPCR=0x50;SPSR=0x01;

// TWI disabled
TWCR=0x00;
/*
// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/128k
// Watchdog Timer interrupt: On
#pragma optsize-
#asm("wdr")
WDTCSR=0x1E;
WDTCSR=0x4E;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
*/
};

void lcd_digit(unsigned int temp)
   {
   if(temp<10000)
     {
     lcd_buf[0]=ascii[temp/1000+2];
     lcd_buf[1]=ascii[(temp%1000)/100+2];
     lcd_buf[2]=ascii[((temp%1000)%100)/10+2]; 
     lcd_buf[3]=ascii[((temp%1000)%100)%10+2];
     }
   else
     {
     lcd_buf[0]=0x10;
     lcd_buf[1]=0x10;
     lcd_buf[2]=0x10; 
     lcd_buf[3]=0x10;
     };
   }; 

void razgon(void)
  {
  if(wz!=wr)
    {
    if(wz<wr)
     {
     if((wr-wz)>1) wr=wr-((wr-wz)>>1);
     else wr--;
     };
    if(wz>wr)
     {
     if((wz-wr)>1) wr=wr+((wz-wr)>>1);
     else wr++;
     };
     OCR1AH=wz>>8;
     OCR1AL=wz&0xFF;
    };
  };

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Crystal Oscillator division factor: 1
#pragma optsize-
CLKPR=0x80;
CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

init();
lcd_buf[0]=0xd3,lcd_buf[1]=0x9a,lcd_buf[2]=0x5f,lcd_buf[3]=0x8f;   //"STOP"
// Global enable interrupts
#asm("sei")

while (1)
      { old_key=((~PIND)&0xe0)>>5;
        delay_ms(20);
        key=((~PIND)&0xe0)>>5;
        if(key!=2) {
        if(old_key!=key) key=0;
        };
            
      switch (key) {
      case 0: {};
      break;
      
      case 7: 
         {
         lcd_buf[0]=0x4f,lcd_buf[1]=0xd6,lcd_buf[2]=0x1b,lcd_buf[3]=0xce;  //""
         wr=1000;
         //while(!fl_speed);              //  
         user_pause(100);       
         PORTD.0=1;                     //  
         user_pause(100);
         PORTD.1=1;                     //   
         user_pause(100);
         wr=1000;
         stop=0;                        // 
          }; 
      break;
       
      case 2: 
         {
         stop=1,wr=1000;PORTD.0=0,PORTD.1=0,fl_alarm=0;
         lcd_buf[0]=0xd3,lcd_buf[1]=0x9a,lcd_buf[2]=0x5f,lcd_buf[3]=0x8f;   //"STOP"
         };
      break;

      case 3:
         {
         if(++reg==5) reg=0; 
         switch (reg) 
           {
           case 0:  lcd_buf[0]=0x00,lcd_buf[1]=0xc6,lcd_buf[2]=0x1b,lcd_buf[3]=0x45; //""
           break;
           case 1:  lcd_buf[0]=0x00,lcd_buf[1]=0x45,lcd_buf[2]=0x5f,lcd_buf[3]=0xce; //""
           break; 
           case 2:  lcd_buf[0]=0xce,lcd_buf[1]=0xcf,lcd_buf[2]=0x4f,lcd_buf[3]=0x8f; //""
           break;
           case 3:  lcd_buf[0]=0x1b,lcd_buf[1]=0xce,lcd_buf[2]=0x5f,lcd_buf[3]=0x8f; //""
           break;
           case 4:  lcd_buf[0]=0x45,lcd_buf[1]=0x5f,lcd_buf[2]=0xc6,lcd_buf[3]=0xce; //""
           break;
           };
         user_pause(200); 
         };
      break;

      case 1:
         { 
         stop=1,wr=1000;PORTD.0=0,PORTD.1=0;
         user_pause(30);
         dir=0;
         lcd_buf[0]=0x4f,lcd_buf[1]=0x8f,lcd_buf[2]=0xcf,lcd_buf[3]=0xdf;       //"" 
         user_pause(50);
         };  
      break;  

      case 6:
         { 
         stop=1,wr=1000;PORTD.0=0,PORTD.1=0;
         user_pause(30);
         dir=1;
         lcd_buf[0]=0xcc,lcd_buf[1]=0x9b,lcd_buf[2]=0xdf,lcd_buf[3]=0x5f;       //""   
         user_pause(50);
         };
      break;
       
      case 5:  if(frec<3000) 
                 {
                 frec=frec+(frec>>5),key=0;      // 
                 if(frec>3000) frec=3000;
                 wz=253895/frec;
                 razgon();
                 };
      break;

      case 4:  if(frec>200) 
                 {
                 frec=frec-(frec>>5),key=0;      //  
                 if(frec<200) frec=200;
                 wz=253895/frec;
                 razgon();
                 };
      break;
      }; 
      
      if(fl_alarm)               // ,
        {
        stop=1;wr=1000;PORTD.0=0,PORTD.1=0;        
        lcd_buf[0]=0x0b,lcd_buf[1]=0x8f,lcd_buf[2]=0xd6,lcd_buf[3]=0xd5; //""
        };  
      
      if(tik>=10) {
      tik=0;
      fl_tik=1;
      speed=TCNT0;
      TCNT0=0;
      if(speed<6) fl_speed=1;
        else fl_speed=0;
      speed_count++;
      if(speed_count>12) {speed_count=0,s_speed=t_speed,t_speed=0;}
        else t_speed=t_speed+speed;
       } else tik++;    
        
      if(fl_tik)                             //      1 
        {
        fl_tik=0;                            //  1  
        
        razgon(); 

        switch (reg) {                       
         case 0: {lcd_digit(frec);};         //  
         break;

         case 1:
          {
          temp=read_adc(6);                  // 
          temp=(read_adc(6))<<2;
          lcd_digit(temp);
          };
         break;

         case 2: 
          {
          temp=read_adc(7);                   // 
          temp=read_adc(7)>>1;
          lcd_digit(temp-(temp>>4));
          }; 
         break;
         
         case 3:
          {
          lcd_digit((speed<<3)+(speed<<2));   //  
          }; 
         break; 
         
         case 4:
          {
          lcd_digit(s_speed);                 //  
          }; 
         break;
        };  
           
      };
      }
}
